unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, DBCtrls, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  ComCtrls, Spin, HTTPApp, HTTPProd;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    WebBrowser1: TWebBrowser;
    Label1: TLabel;
    Label2: TLabel;
    DBLookupComboBox1: TDBLookupComboBox;
    DBLookupComboBox2: TDBLookupComboBox;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    ADOQuery2: TADOQuery;
    ADOQuery2PartNo: TFloatField;
    ADOQuery2OrderNO: TFloatField;
    ADOQuery2Description: TWideStringField;
    ADOQuery2Qty: TIntegerField;
    ADOQuery2ListPrice: TFloatField;
    ADOQuery2Discount: TFloatField;
    ADOQuery2amount: TFloatField;
    DataSource1: TDataSource;
    Button1: TButton;
    Label4: TLabel;
    SpinEdit2: TSpinEdit;
    Label5: TLabel;
    Label6: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button7: TButton;
    Button8: TButton;
    PageProducer1: TPageProducer;
    ADOQuery1OrderNo: TFloatField;
    ADOQuery1CustNo: TFloatField;
    ADOQuery1empno: TIntegerField;
    ADOQuery1SalesPerson: TWideStringField;
    ADOQuery1SaleDate: TDateTimeField;
    ADOQuery1ShipDate: TDateTimeField;
    ADOQuery1ShipVIA: TWideStringField;
    ADOQuery1Freight: TFloatField;
    ADOQuery1Company: TWideStringField;
    ADOQuery1Addr1: TWideStringField;
    ADOQuery1Addr2: TWideStringField;
    ADOQuery1addr3: TWideStringField;
    Button9: TButton;
    Button6: TButton;
    procedure DBLookupComboBox1CloseUp(Sender: TObject);
    procedure DBLookupComboBox2CloseUp(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpinEdit2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    qs1,qs2:string;
    go_rec:integer;
  end;

var
  Form1: TForm1;
  gdataset:TADOQuery;
  activeForm:TForm1;
  tot_name:Tstringlist;
  tot:array of integer;
  function reportcreate(url:string):string;
  function getres(nam:string):string;

implementation

uses HTMLReportExeProtocol;

{$R *.dfm}
{$R invoice.res}

function getres(nam:string):string;
var hand:HGLOBAL;
    hr :HRSRC;
    content :Pchar;
    TotalSize:integer;
begin
  try
    hand :=0;
    hr :=Findresource(hInstance, Pchar(nam), '#23');
    TotalSize := SizeOfResource(hInstance, hr);
    content :=LockResource(LoadResource(hInstance,hr));
    result:=content;
  except
    result:='';
  end;
end;

function reportcreate(url:string):string;
var subtotal,total:integer;
    i:integer;
    page_no,go_type:integer;
begin
   i:=pos('-',url);
   go_type:=strtoint(copy(url,i+1,length(url)-1));
   url:=copy(url,1,i-1);
   page_no:=strtoint(url);
   gdataset:=Form1.ADOQuery1;
   case go_type of
      1:gdataset.First;
      2:gdataset.Prior;
      3:gdataset.Next;
      4:gdataset.Last;
   else
      for i:=1 to page_no-1 do
         gdataset.Next;
   end;
   result:='';
//   Form1.PageProducer1.HTMLFile:=Extractfilepath(application.ExeName)+'DetailHeader.htm';
   Form1.PageProducer1.HTMLDoc.Text:=getres('DetailHeader');
   result:=Form1.PageProducer1.Content;
   Form1.PageProducer1.HTMLDoc.Text:=getres('DetailColumnHeader');
   result:=result+Form1.PageProducer1.Content;
   gdataset:=Form1.ADOQuery2;
   tot[0]:=0;
   while not gdataset.Eof do
   begin
      tot[0]:=tot[0]+gdataset.fieldbyname('amount').AsInteger;
      Form1.PageProducer1.HTMLDoc.Text:=getres('Detail');
      result:=result+Form1.PageProducer1.Content;
      gdataset.Next;
   end;
   gdataset:=Form1.ADOQuery1;
   tot[1]:=tot[0]+gdataset.fieldbyname('Freight').AsInteger;
   Form1.PageProducer1.HTMLDoc.Text:=getres('DetailFooter');
   result:=result+Form1.PageProducer1.Content;
end;

procedure TForm1.DBLookupComboBox1CloseUp(Sender: TObject);
begin
   qs1:=DBLookupComboBox1.Text;
end;

procedure TForm1.DBLookupComboBox2CloseUp(Sender: TObject);
begin
   qs2:=DBLookupComboBox2.Text;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   ADOQuery1.Active:=false;
   if qs1='' then
      ADOQuery1.SQL.Strings[3]:=''
   else
      ADOQuery1.SQL.Strings[3]:='  and a.OrderNo>='+qs1;
   if qs2='' then
      ADOQuery1.SQL.Strings[4]:=''
   else
      ADOQuery1.SQL.Strings[4]:='  and a.OrderNo<='+qs2;
   ADOQuery1.active:=true;
   ADOQuery2.Active:=true;
   SpinEdit2.Value:=1;
   SpinEdit2.MaxValue:=ADOQuery1.RecordCount;
   Label6.Caption:='@'+formatfloat('000',ADOQuery1.RecordCount)+'';
   ADOQuery1.First;
   PageControl1.ActivePageIndex:=1;
   WebBrowser1.Navigate('HTMLReport:1-0');
end;

procedure TForm1.PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
begin
   if tot_name.IndexOf(TagString)>=0 then
      ReplaceText:=formatfloat('###,###',tot[tot_name.IndexOf(TagString)])
   else
      if not (gdataset.FieldByName(TagString)=nil) then
         ReplaceText:=gdataset.FieldByName(TagString).AsString;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
   for i:=0 to PageControl1.PageCount-1 do
      PageControl1.Pages[i].TabVisible:=false;
   PageControl1.ActivePageIndex:=0;
   RegisterHTMLReportProtocol;
   tot_name:=TStringlist.Create;
   tot_name.Add('SubTotal');
   tot_name.Add('Total');
   setlength(tot,tot_name.count);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   UnRegisterHTMLReportProtocol;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
   WebBrowser1.Navigate('HTMLReport:'+inttostr(SpinEdit2.Value)+'-'+inttostr(go_rec));
   Button2.Enabled:=(SpinEdit2.Value>1);
   Button3.Enabled:=(SpinEdit2.Value>1);
   Button4.Enabled:=(SpinEdit2.Value<SpinEdit2.MaxValue);
   Button5.Enabled:=(SpinEdit2.Value<SpinEdit2.MaxValue);
   go_rec:=0;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   go_rec:=1;
   SpinEdit2.Value:=1;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
   go_rec:=4;
   SpinEdit2.Value:=SpinEdit2.MaxValue;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   go_rec:=2;
   SpinEdit2.Value:=SpinEdit2.Value-1;

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   go_rec:=3;
   SpinEdit2.Value:=SpinEdit2.Value+1;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  null : OLEvariant ;
begin
   if webbrowser1.QueryStatusWB(OLECMDID_PRINTPREVIEW)=3 then
      webbrowser1.ExecWB(OLECMDID_PRINTPREVIEW, OLECMDEXECOPT_DODEFAULT,EmptyParam,EmptyParam)
   else
   begin
      null :=0 ;
      try
        webBrowser1.EXECWB(OLECMDID_PRINT, OLECMDEXECOPT_PROMPTUSER,
                         null, null ) ;
      except
      end ;
   end;   
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
   ADOQuery1.Active:=false;
   ADOQuery1.SQL.Strings[3]:='';
   ADOQuery1.SQL.Strings[4]:='';
   ADOQuery1.active:=true;
   ADOQuery2.Active:=false;
   PageControl1.ActivePageIndex:=0;
end;

end.
